<template>
  <v-dialog v-model="dialog" persistent width="800px">
    <v-card>
      <v-card-title>
        <span class="headline">
          <v-icon color="info"> insert_drive_file </v-icon>
          รายละเอียด Partner
        </span>
      </v-card-title>
      <v-card-text>
        <v-container>
          <!-- {{ propObj.status }} -->
          <v-row>
            <v-col cols="12">
              <h3>ข้อมูล</h3>
            </v-col>
            <v-col cols="12" sm="6" md="6">
              <v-text-field
                label="ชื่อ"
                v-model="objPartner.firstName"
                disabled
                outlined
                rounded
              ></v-text-field>
            </v-col>
            <v-col cols="12" sm="6" md="6">
              <v-text-field
                label="นามสกุล"
                v-model="objPartner.lastName"
                disabled
                outlined
                rounded
              ></v-text-field>
            </v-col>
            <v-col cols="12" sm="6" md="6">
              <v-text-field
                label="E-mail"
                v-model="objPartner.email"
                disabled
                outlined
                rounded
              ></v-text-field>
            </v-col>
            <v-col cols="12" sm="6" md="6">
              <v-text-field
                label="เบอร์โทรติดต่อ"
                v-model="objPartner.telNo"
                disabled
                outlined
                rounded
              ></v-text-field>
            </v-col>
            <v-col cols="12" sm="6" md="6">
              <v-text-field
                label="ประเภทผู้ร่วมลงทุน"
                v-model="objPartner.partnerType"
                disabled
                outlined
                rounded
              ></v-text-field>
            </v-col>
            <v-col cols="12" sm="6" md="6">
              <v-text-field
                :label="`${
                  objPartner.partnerType == 'PE'
                    ? 'เลขบัตรประชาชน'
                    : 'เลขนิติบุคคล'
                }`"
                v-model="objPartner.partnerNumber"
                disabled
                outlined
                rounded
              ></v-text-field>
            </v-col>
            <v-col cols="12">
              <h3>รายละเอียดที่อยู่</h3>
            </v-col>
            <v-col cols="12">
              <v-textarea
                outlined
                rounded
                disabled
                name="input-7-4"
                v-model="objPartner.partnerAddress"
                label="ที่อยู่"
              ></v-textarea>
            </v-col>
          </v-row>
        </v-container>
      </v-card-text>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn
          color="success darken-1"
          text
          @click="showDialogConfirm(objPartner, 'approve')"
          v-if="objPartner.status === 'W'"
        >
          อนุมัติ
        </v-btn>
        <v-btn
          color="red darken-1"
          text
          @click="showDialogConfirm(objPartner, 'reject')"
          v-if="objPartner.status === 'W'"
        >
          ไม่อนุมัติ
        </v-btn>
        <v-btn color="info darken-1" text @click="$emit('update:close', false)">
          ปิด
        </v-btn>
      </v-card-actions>
      <DialogConfirm
        :dialog="dialogConfirm"
        :title="obj.title"
        :status="status"
      >
        <template v-slot:confirm>
          <v-btn
            color="success"
            text
            :disabled="loading"
            :loading="loading"
            @click="confirm"
          >
            ใช่
          </v-btn>
        </template>
        <template v-slot:close>
          <v-btn
            color="error"
            text
            :disabled="loading"
            @click="dialogConfirm = false"
          >
            ไม่ใช่
          </v-btn>
        </template>
      </DialogConfirm>
    </v-card>
  </v-dialog>
</template>

<script>
import DialogConfirm from "../dialog/DialogConfirm";
export default {
  props: ["dialog", "objPartner"],
  components: {
    DialogConfirm,
  },
  data() {
    return {
      dialogConfirm: false,
      loading: false,
      obj: {},
      title: "",
      remark: "",
      status: "",
    };
  },
  methods: {
    showDialogConfirm(data, status) {
      this.obj = data;
      this.status = status;
      this.obj.title =
        status == "approve"
          ? "คุณต้องการอนุมัติหรือไม่"
          : "คุณต้องการไม่อนุมัติหรือไม่";
      this.dialogConfirm = true;
    },
    async confirm() {
      this.loading = true;
      const param = {
        AccountId: this.obj.accountId,
        Status: this.status,
        Email: this.obj.email,
      };
      await this.$store.dispatch("auth/approveAccount", param);
      let result = this.$store.getters["auth/result"];
      if (result == true) {
        await this.$store.dispatch("snackbar/showSnack", {
          text: "อนุมัติสำเร็จ",
          color: "success",
          timeout: 3000,
        });
        this.dialogConfirm = false;
        this.loading = false;
        this.$emit("update:close", false);
      } else {
        await this.$store.dispatch("snackbar/showSnack", {
          text: "ข้อมูลจากระบบผิดพลาด",
          color: "red",
          timeout: 3000,
        });
        this.loading = false;
      }
      this.$emit("update-table", true);
    },
  },
};
</script>

<style>
</style>